#include <stm32f4xx.h>

// Inicijalizacija PWM na GPIOE pinu 6

void TIM_init(void)
{
	TIM_TimeBaseInitTypeDef  TIM_BaseStruct;
  GPIO_InitTypeDef GPIO_InitStruct;
	
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_TIM9, ENABLE);
 
	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOE, ENABLE);
	
	GPIO_InitStruct.GPIO_Pin = GPIO_Pin_6;
  GPIO_InitStruct.GPIO_Mode = GPIO_Mode_AF;
  GPIO_InitStruct.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStruct.GPIO_PuPd = GPIO_PuPd_NOPULL;
  GPIO_Init(GPIOE, &GPIO_InitStruct);
	
	TIM_BaseStruct.TIM_Prescaler=9999;
	TIM_BaseStruct.TIM_CounterMode=TIM_CounterMode_Up;
	TIM_BaseStruct.TIM_Period=16799;
	TIM_BaseStruct.TIM_ClockDivision=TIM_CKD_DIV1;
	TIM_BaseStruct.TIM_RepetitionCounter=0;
	TIM_TimeBaseInit(TIM9, &TIM_BaseStruct);
	TIM_Cmd(TIM9, ENABLE);
	
	GPIO_PinAFConfig(GPIOE, GPIO_PinSource6, GPIO_AF_TIM9);
}


void Start_PWM(uint32_t dutycycle)
{
	TIM_OCInitTypeDef TIM_OCStruct;
	
	TIM_OCStruct.TIM_OCMode = TIM_OCMode_PWM1;
  TIM_OCStruct.TIM_OutputState = TIM_OutputState_Enable;
  TIM_OCStruct.TIM_OCPolarity = TIM_OCPolarity_High;
	TIM_OCStruct.TIM_Pulse = dutycycle*168; 
  TIM_OC2Init(TIM9, &TIM_OCStruct);
  TIM_OC2PreloadConfig(TIM9, TIM_OCPreload_Enable);
    
}

void Stop_PWM(void)
{
	TIM_OCInitTypeDef TIM_OCStruct;
	TIM_OCStruct.TIM_OCMode = TIM_OCMode_PWM1;
  TIM_OCStruct.TIM_OutputState = TIM_OutputState_Enable;
  TIM_OCStruct.TIM_OCPolarity = TIM_OCPolarity_High;
	TIM_OCStruct.TIM_Pulse = 0; 
  TIM_OC2Init(TIM9, &TIM_OCStruct);
  TIM_OC2PreloadConfig(TIM9, TIM_OCPreload_Enable);
}

	
