#include <stm32f4xx.h>
#include <stdio.h>
#include <string.h>

extern void LED_init(void);
extern void USART1_init(uint32_t baudrate);
extern void USART2_init(uint32_t baudrate);
extern void USART_puts(USART_TypeDef* USARTx, volatile char *s);
extern void TIM_init(void);
extern void Start_PWM(uint32_t dutycycle);
extern void Stop_PWM(void);
extern void ADC_init(void);
extern int ADC1_Convert(void);
extern int ADC2_Convert(void);
extern void htu21_init(void);
extern float htu21_readTemperature(void);
extern void htu21_softwareReset(void);
extern float htu21_readHumidity(void);
extern float htu21_readCompensatedHumidity(void);
extern void ClearCommand(void);
extern void SendData(USART_TypeDef* USARTx, volatile char *s);
extern void web(float Temperature, float Humidity, float SoilHumidity1, float SoilHumidity2);

extern __IO uint32_t TimmingDelay;

void SystickDelayMs(uint32_t time)
{
	TimmingDelay = time;
	while(TimmingDelay !=0);
}

int main()
{
	int pause;	
	int i;
	volatile float SoilHumidity1;
	volatile float SoilHumidity2;
	volatile float Temperature;
	volatile float Humidity;
	
	SysTick_Config(SystemCoreClock/1000);
	USART1_init(9600);
  USART2_init(9600);
	LED_init();
	SendData(USART2,"USART1 inicijaliziran\r\n");
	htu21_init();
	TIM_init();
	ADC_init();
	
	
	while(1)
	{
		
		i = ADC1_Convert();
		SoilHumidity1 = ((1 - (float)i/4096)*100);
		SystickDelayMs(1000);
		i = ADC2_Convert();
		SoilHumidity2 = ((1 - (float)i/4096)*100);
		Temperature = htu21_readTemperature();
		Humidity = htu21_readCompensatedHumidity();
		
		
		web(Temperature,Humidity,SoilHumidity1,SoilHumidity2);
		
		//if(((SoilHumidity1+SoilHumidity2)/2) > 40)
		//{
		//	Stop_PWM();
		//}
		//else
		//{
		//	Start_PWM(100);
		//}
		
	}
}





